//
// System.Drawing.Pens.cs
//
// Authors:
//   Matt Stump (mstump@swfo.arizona.edu)
//   Ravindra (rkumar@novell.com)
//
// Copyright (C) 2002 Ximian, Inc.  http://www.ximian.com
// Copyright (C) 2004 Novell, Inc. http://www.novell.com
//

//
// Copyright (C) 2004 Novell, Inc (http://www.novell.com)
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;

namespace System.Drawing
{
	public sealed class Pens
	{
		private Pens () { }

		public static Pen AliceBlue {
			get {
				Pen pen = new Pen (Color.AliceBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen AntiqueWhite {
			get {
				Pen pen = new Pen (Color.AntiqueWhite);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Aqua {
			get {
				Pen pen = new Pen (Color.Aqua);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Aquamarine {
			get {
				Pen pen = new Pen (Color.Aquamarine);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Azure {
			get {
				Pen pen = new Pen (Color.Azure);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Beige {
			get {
				Pen pen = new Pen (Color.Beige);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Bisque {
			get {
				Pen pen = new Pen (Color.Bisque);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Black {
			get {
				Pen pen = new Pen (Color.Black);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen BlanchedAlmond {
			get {
				Pen pen = new Pen (Color.BlanchedAlmond);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Blue {
			get {
				Pen pen = new Pen (Color.Blue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen BlueViolet {
			get {
				Pen pen = new Pen (Color.BlueViolet);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Brown {
			get {
				Pen pen = new Pen (Color.Brown);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen BurlyWood {
			get {
				Pen pen = new Pen (Color.BurlyWood);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen CadetBlue {
			get {
				Pen pen = new Pen (Color.CadetBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Chartreuse {
			get {
				Pen pen = new Pen (Color.Chartreuse);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Chocolate {
			get {
				Pen pen = new Pen (Color.Chocolate);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Coral {
			get {
				Pen pen = new Pen (Color.Coral);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen CornflowerBlue {
			get {
				Pen pen = new Pen (Color.CornflowerBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Cornsilk {
			get {
				Pen pen = new Pen (Color.Cornsilk);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Crimson {
			get {
				Pen pen = new Pen (Color.Crimson);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Cyan {
			get {
				Pen pen = new Pen (Color.Cyan);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkBlue {
			get {
				Pen pen = new Pen (Color.DarkBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkCyan {
			get {
				Pen pen = new Pen (Color.DarkCyan);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkGoldenrod {
			get {
				Pen pen = new Pen (Color.DarkGoldenrod);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkGray {
			get {
				Pen pen = new Pen (Color.DarkGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkGreen {
			get {
				Pen pen = new Pen (Color.DarkGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkKhaki {
			get {
				Pen pen = new Pen (Color.DarkKhaki);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkMagenta {
			get {
				Pen pen = new Pen (Color.DarkMagenta);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkOliveGreen {
			get {
				Pen pen = new Pen (Color.DarkOliveGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkOrange {
			get {
				Pen pen = new Pen (Color.DarkOrange);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkOrchid {
			get {
				Pen pen = new Pen (Color.DarkOrchid);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkRed {
			get {
				Pen pen = new Pen (Color.DarkRed);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkSalmon {
			get {
				Pen pen = new Pen (Color.DarkSalmon);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkSeaGreen {
			get {
				Pen pen = new Pen (Color.DarkSeaGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkSlateBlue {
			get {
				Pen pen = new Pen (Color.DarkSlateBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkSlateGray {
			get {
				Pen pen = new Pen (Color.DarkSlateGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkTurquoise {
			get {
				Pen pen = new Pen (Color.DarkTurquoise);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DarkViolet {
			get {
				Pen pen = new Pen (Color.DarkViolet);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DeepPink {
			get {
				Pen pen = new Pen (Color.DeepPink);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DeepSkyBlue {
			get {
				Pen pen = new Pen (Color.DeepSkyBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DimGray {
			get {
				Pen pen = new Pen (Color.DimGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen DodgerBlue {
			get {
				Pen pen = new Pen (Color.DodgerBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Firebrick {
			get {
				Pen pen = new Pen (Color.Firebrick);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen FloralWhite {
			get {
				Pen pen = new Pen (Color.FloralWhite);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen ForestGreen {
			get {
				Pen pen = new Pen (Color.ForestGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Fuchsia {
			get {
				Pen pen = new Pen (Color.Fuchsia);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Gainsboro {
			get {
				Pen pen = new Pen (Color.Gainsboro);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen GhostWhite {
			get {
				Pen pen = new Pen (Color.GhostWhite);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Gold {
			get {
				Pen pen = new Pen (Color.Gold);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Goldenrod {
			get {
				Pen pen = new Pen (Color.Goldenrod);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Gray {
			get {
				Pen pen = new Pen (Color.Gray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Green {
			get {
				Pen pen = new Pen (Color.Green);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen GreenYellow {
			get {
				Pen pen = new Pen (Color.GreenYellow);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Honeydew {
			get {
				Pen pen = new Pen (Color.Honeydew);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen HotPink {
			get {
				Pen pen = new Pen (Color.HotPink);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen IndianRed {
			get {
				Pen pen = new Pen (Color.IndianRed);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Indigo {
			get {
				Pen pen = new Pen (Color.Indigo);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Ivory {
			get {
				Pen pen = new Pen (Color.Ivory);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Khaki {
			get {
				Pen pen = new Pen (Color.Khaki);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Lavender {
			get {
				Pen pen = new Pen (Color.Lavender);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LavenderBlush {
			get {
				Pen pen = new Pen (Color.LavenderBlush);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LawnGreen {
			get {
				Pen pen = new Pen (Color.LawnGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LemonChiffon {
			get {
				Pen pen = new Pen (Color.LemonChiffon);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightBlue {
			get {
				Pen pen = new Pen (Color.LightBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightCoral {
			get {
				Pen pen = new Pen (Color.LightCoral);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightCyan {
			get {
				Pen pen = new Pen (Color.LightCyan);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightGoldenrodYellow {
			get {
				Pen pen = new Pen (Color.LightGoldenrodYellow);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightGray {
			get {
				Pen pen = new Pen (Color.LightGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightGreen {
			get {
				Pen pen = new Pen (Color.LightGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightPink {
			get {
				Pen pen = new Pen (Color.LightPink);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightSalmon {
			get {
				Pen pen = new Pen (Color.LightSalmon);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightSeaGreen {
			get {
				Pen pen = new Pen (Color.LightSeaGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightSkyBlue {
			get {
				Pen pen = new Pen (Color.LightSkyBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightSlateGray {
			get {
				Pen pen = new Pen (Color.LightSlateGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightSteelBlue {
			get {
				Pen pen = new Pen (Color.LightSteelBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LightYellow {
			get {
				Pen pen = new Pen (Color.LightYellow);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Lime {
			get {
				Pen pen = new Pen (Color.Lime);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen LimeGreen {
			get {
				Pen pen = new Pen (Color.LimeGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Linen {
			get {
				Pen pen = new Pen (Color.Linen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Magenta {
			get {
				Pen pen = new Pen (Color.Magenta);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Maroon {
			get {
				Pen pen = new Pen (Color.Maroon);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumAquamarine {
			get {
				Pen pen = new Pen (Color.MediumAquamarine);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumBlue {
			get {
				Pen pen = new Pen (Color.MediumBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumOrchid {
			get {
				Pen pen = new Pen (Color.MediumOrchid);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumPurple {
			get {
				Pen pen = new Pen (Color.MediumPurple);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumSeaGreen {
			get {
				Pen pen = new Pen (Color.MediumSeaGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumSlateBlue {
			get {
				Pen pen = new Pen (Color.MediumSlateBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumSpringGreen {
			get {
				Pen pen = new Pen (Color.MediumSpringGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumTurquoise {
			get {
				Pen pen = new Pen (Color.MediumTurquoise);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MediumVioletRed {
			get {
				Pen pen = new Pen (Color.MediumVioletRed);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MidnightBlue {
			get {
				Pen pen = new Pen (Color.MidnightBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MintCream {
			get {
				Pen pen = new Pen (Color.MintCream);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen MistyRose {
			get {
				Pen pen = new Pen (Color.MistyRose);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Moccasin {
			get {
				Pen pen = new Pen (Color.Moccasin);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen NavajoWhite {
			get {
				Pen pen = new Pen (Color.NavajoWhite);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Navy {
			get {
				Pen pen = new Pen (Color.Navy);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen OldLace {
			get {
				Pen pen = new Pen (Color.OldLace);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Olive {
			get {
				Pen pen = new Pen (Color.Olive);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen OliveDrab {
			get {
				Pen pen = new Pen (Color.OliveDrab);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Orange {
			get {
				Pen pen = new Pen (Color.Orange);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen OrangeRed {
			get {
				Pen pen = new Pen (Color.OrangeRed);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Orchid {
			get {
				Pen pen = new Pen (Color.Orchid);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PaleGoldenrod {
			get {
				Pen pen = new Pen (Color.PaleGoldenrod);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PaleGreen {
			get {
				Pen pen = new Pen (Color.PaleGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PaleTurquoise {
			get {
				Pen pen = new Pen (Color.PaleTurquoise);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PaleVioletRed {
			get {
				Pen pen = new Pen (Color.PaleVioletRed);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PapayaWhip {
			get {
				Pen pen = new Pen (Color.PapayaWhip);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PeachPuff {
			get {
				Pen pen = new Pen (Color.PeachPuff);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Peru {
			get {
				Pen pen = new Pen (Color.Peru);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Pink {
			get {
				Pen pen = new Pen (Color.Pink);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Plum {
			get {
				Pen pen = new Pen (Color.Plum);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen PowderBlue {
			get {
				Pen pen = new Pen (Color.PowderBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Purple {
			get {
				Pen pen = new Pen (Color.Purple);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Red {
			get {
				Pen pen = new Pen (Color.Red);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen RosyBrown {
			get {
				Pen pen = new Pen (Color.RosyBrown);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen RoyalBlue {
			get {
				Pen pen = new Pen (Color.RoyalBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SaddleBrown {
			get {
				Pen pen = new Pen (Color.SaddleBrown);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Salmon {
			get {
				Pen pen = new Pen (Color.Salmon);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SandyBrown {
			get {
				Pen pen = new Pen (Color.SandyBrown);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SeaGreen {
			get {
				Pen pen = new Pen (Color.SeaGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SeaShell {
			get {
				Pen pen = new Pen (Color.SeaShell);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Sienna {
			get {
				Pen pen = new Pen (Color.Sienna);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Silver {
			get {
				Pen pen = new Pen (Color.Silver);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SkyBlue {
			get {
				Pen pen = new Pen (Color.SkyBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SlateBlue {
			get {
				Pen pen = new Pen (Color.SlateBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SlateGray {
			get {
				Pen pen = new Pen (Color.SlateGray);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Snow {
			get {
				Pen pen = new Pen (Color.Snow);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SpringGreen {
			get {
				Pen pen = new Pen (Color.SpringGreen);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen SteelBlue {
			get {
				Pen pen = new Pen (Color.SteelBlue);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Tan {
			get {
				Pen pen = new Pen (Color.Tan);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Teal {
			get {
				Pen pen = new Pen (Color.Teal);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Thistle {
			get {
				Pen pen = new Pen (Color.Thistle);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Tomato {
			get {
				Pen pen = new Pen (Color.Tomato);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Transparent {
			get {
				Pen pen = new Pen (Color.Transparent);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Turquoise {
			get {
				Pen pen = new Pen (Color.Turquoise);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Violet {
			get {
				Pen pen = new Pen (Color.Violet);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Wheat {
			get {
				Pen pen = new Pen (Color.Wheat);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen White {
			get {
				Pen pen = new Pen (Color.White);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen WhiteSmoke {
			get {
				Pen pen = new Pen (Color.WhiteSmoke);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen Yellow {
			get {
				Pen pen = new Pen (Color.Yellow);
				pen.isModifiable = false;
				return pen;
			}
		}

		public static Pen YellowGreen {
			get {
				Pen pen = new Pen (Color.YellowGreen);
				pen.isModifiable = false;
				return pen;
			}
		}
	}
}
